<template>
  <el-drawer
    :visible.sync="homeFilter"
    :before-close="toggleHomeFilter"
    :withHeader="false"
    :show-close="false"
    style="background: 0"
    custom-class="filter-drawer"
  >
    <div class="filter-drawer__content">
      <div class="filter-drawer__top">
        <div v-if="filter_active == 'style'">
          <div class="setting-item">
            <div class="setting-item__input">
              <el-input
                border
                line
                v-model="searchStyles"
                placeholder="Search styles"
              />
            </div>
          </div>

          <el-checkbox-group
            v-if="globalStyles"
            v-model="filterData.styles"
            class="styles__row"
          >
            <div
              class="styles__item"
              :key="tagIndex"
              v-for="(tag, tagIndex) in filteredList()"
              @click="addStyleButton(tag.name)"
            >
              <!-- <el-checkbox
                  class="styles__checkbox"
                  :label="tag.name"
                ></el-checkbox> -->
            </div>
          </el-checkbox-group>
        </div>

        <div v-if="filter_active == 'payment'">
          <el-checkbox-group v-model="filterData.payments">
            <div class="payment_types">
              <div class="payment_types__title">
                {{ $t('payment_type.per_file') }}
              </div>
              <div class="payment_types__descr">
                {{ $t('payment_info.per_file') }}
              </div>
              <div class="payment_types__checkbox">
                <el-checkbox label="PER_FILE" switch />
              </div>
            </div>
            <div class="payment_types">
              <div class="payment_types__title">
                {{ $t('payment_type.fixed') }}
              </div>
              <div class="payment_types__descr">
                {{ $t('payment_info.fixed') }}
              </div>
              <div class="payment_types__checkbox">
                <el-checkbox label="FIXED" switch />
              </div>
            </div>
            <div class="payment_types">
              <div class="payment_types__title">
                {{ $t('payment_type.donation') }}
              </div>
              <div class="payment_types__descr">
                {{ $t('payment_info.donation') }}
              </div>
              <div class="payment_types__checkbox">
                <el-checkbox label="DONATION" switch />
              </div>
            </div>
          </el-checkbox-group>
        </div>

        <div v-if="filter_active == 'sort'">
          <el-radio-group v-model="filterData.sortBy">
            <div>
              <el-radio label="Newest">Newest</el-radio>
            </div>
            <div>
              <el-radio label="Popular">Popular</el-radio>
            </div>
            <div>
              <el-radio label="Most active">Most active</el-radio>
            </div>
          </el-radio-group>
        </div>

        <div v-if="filter_active == 'all'">
          <div @click="filter_active = 'style'" class="filter__item">
            <div class="filter__title">Style</div>
            <div class="filter__value">
              <div class="filter__tags" v-if="filterData.styles.length">
                <div
                  :key="tagIndex"
                  v-for="(tag, tagIndex) in filterData.styles"
                >
                  <el-tag
                    :disable-transitions="false"
                    @close="removeStyleButton(tag)"
                    type="info"
                    closable
                  >
                    <span>{{ tag }}</span>
                  </el-tag>
                </div>
              </div>
              <div v-else>All styles</div>
            </div>
          </div>
          <div @click="filter_active = 'payment'" class="filter__item">
            <div class="filter__title">Payment type</div>
            <div class="filter__value">
              <div class="filter__tags" v-if="filterData.payments.length">
                <div
                  :key="tagIndex"
                  v-for="(tag, tagIndex) in filterData.payments"
                >
                  <el-tag
                    :disable-transitions="false"
                    @close="removeStyleButton(tag)"
                    type="info"
                    closable
                  >
                    <span>{{ tag }}</span>
                  </el-tag>
                </div>
              </div>
              <div v-else>All types</div>
            </div>
          </div>
          <div class="filter__item">
            <div class="filter__title">Sort by</div>
            <div class="filter__value">
              <el-select v-model="filterData.sortBy" border line>
                <el-option value="Newest">Newest</el-option>
                <el-option value="Popular">Popular</el-option>
                <el-option value="Active">Most active</el-option>
              </el-select>
            </div>
          </div>
          <!-- <div class="filter__result">
            Search result <span>{{ totalResult.all }} </span>
          </div> -->
        </div>
      </div>
      <div>
        <div v-if="filter_active !== 'all'" style="text-align: center">
          <Button size="inline" @click="filter_active = 'all'">
            <svg-icon name="checked" class="icon-radius" style="margin: 0" />
          </Button>
        </div>
        <div v-if="filter_active == 'all'">
          <Button size="small" @click="filter_clear()"> Show results </Button>
        </div>
      </div>
    </div>
  </el-drawer>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  useAsync,
  useMeta,
  computed,
  ref,
  watch
} from '@nuxtjs/composition-api'

import {
  useGetPageQuery,
  useGetSearchPhotographersQuery,
  useGetStyleQuery
} from '~/sdk/hooks'

import useHomeTab from '@/hooks/home-tab'

import Button from '@/components/ui/Button.vue'
import elDrawer from '@/components/element/Drawer.vue'
import elSelect from '@/components/element/Select.vue'
export default defineComponent({
  name: 'FilterSearch',
  components: {
    Button,
    elDrawer,
    elSelect
  },

  head: {},
  setup(_, { root }) {
    const { app, error } = useContext()
    const currentUser = computed(() => root.$accessor.auth.user)
    const {
      homeTab,
      homeFilter,
      toggleHomeFilter,
      setFilterData,
      filterData
    } = useHomeTab()

    const modalFilter = ref(homeFilter)
    // const filterData = ref({
    //   activeFilter: 'all' as string,
    //   styles: [] as any,
    //   payments: [] as any,
    //   types: String,
    //   sortBy: 'Popular' as string,
    //   //location: { lat: 0, lng: 0 } as any
    //   location: null
    // })
    const filter_active = ref('all')
    const filter_result = ref<any>([] as any)
    // clear filter
    const filter_clear = () => {
      filter_active.value = 'all'
      filterData.value.styles = []
      filterData.value.payments = []
      filterData.value.sortBy = 'Popular'
    }

    // get all styles
    const { result: globalStyles } = useGetStyleQuery()
    const searchStyles = ref('')
    const filteredList = () => {
      if (searchStyles.value !== '') {
        return globalStyles.value.styles.filter(item => {
          return item.name
            .toLowerCase()
            .startsWith(searchStyles.value.toLowerCase())
        })
      } else {
        return globalStyles.value.styles
      }
    }
    const addStyleButton = (item: any) => {
      if (!filterData.value.styles) return
      if (!filterData.value.styles.includes(item)) {
        filterData.value.styles.push(item)
        searchStyles.value = ''
      }
    }
    const removeStyleButton = (tag: any) => {
      filterData.value.styles.splice(filterData.value.styles.indexOf(tag), 1)
    }

    watch(
      () => homeFilter.value,
      () => {
        filterData.value.activeFilter = 'all'
      }
    )

    return {
      currentUser,
      homeFilter,
      toggleHomeFilter,
      //filter
      filter_active,
      setFilterData,
      filter_result,
      filter_clear,

      modalFilter,
      filterData,
      globalStyles,
      searchStyles,
      filteredList,
      addStyleButton,
      removeStyleButton
    }
  }
})
</script>

<style lang="scss" scoped>
.filter {
  &__title {
    text-align: left;
    letter-spacing: 0px;
    color: #7683ad;
    font-weight: 500;
    font-size: 18px;
    line-height: 23px;
  }
  &__value {
    letter-spacing: 0px;
    color: #ffffff;
    font-size: 24px;
    line-height: 30px;
  }
  &__tags {
    display: flex;
    flex-wrap: wrap;
    margin-bottom: -7px;
    margin-top: 10px;
    > * {
      margin-right: 7px;
      margin-bottom: 7px;
    }
  }
  &__result {
    margin-top: 20px;
    padding: 10px 20px;
    display: flex;
    align-items: center;
    justify-content: space-between;
    border: 2px solid #373e57;
    border-radius: 10px;
    letter-spacing: 0px;
    color: #7683ad;
    font-weight: 500;
    font-size: 18px;
    line-height: 23px;
    span {
      color: #fff;
      display: inline-block;
      padding-left: 15px;
    }
  }
  &__item {
    background: #384057;
    border-radius: 10px;
    padding: 10px 15px;
    margin-bottom: 10px;
    cursor: pointer;
    &:last-child {
      margin-bottom: 0px;
    }
    &::v-deep {
      .el-select {
        margin: 0 -16px -12px -16px;
        .el-input__inner {
          padding-left: 16px !important;
          padding-right: 16px !important;
          padding-bottom: 12px !important;
        }
        .el-select__tags {
          padding-left: 10px;
          padding-bottom: 10px;
          margin-top: -2px;
        }
      }
      .el-input__inner {
        height: auto;
        margin: 0 !important;
        line-height: 1;
        padding: 0 !important;
        border: 0 !important;
        background: 0;
        border-radius: 0;
        color: #fff;
        font-size: 30px;
        line-height: 30px;
      }
    }
  }
}
.payment_types {
  background: #384057;
  border-radius: 10px;
  padding: 12px 15px;
  margin-bottom: 8px;
  &:last-child {
    margin-bottom: 0px;
  }
  &__title {
    font-size: 18px;
    line-height: 23px;
    font-weight: bold;
    letter-spacing: 0.9px;
    color: #ffffff;
    text-transform: uppercase;
  }
  &__descr {
    font-size: 16px;
    line-height: 20px;
    font-weight: 500;
    letter-spacing: 0px;
    color: #9badd6;
  }
  &__checkbox {
    margin-top: 15px;
  }
}
.styles {
  &__row {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-gap: 15px;
    margin-top: 25px;
  }
  &__item {
    height: 150px;
    background-size: cover;
    background-position: center;
    border-radius: 10px;
    display: flex;
    align-items: flex-end;
    position: relative;
    padding-bottom: 20px;
    overflow: hidden;
    &::before {
      content: '';
      position: absolute;
      left: 0px;
      right: 0px;
      bottom: 0px;
      height: 80px;
      background: linear-gradient(
        180deg,
        #21283c00 0%,
        #14182252 21%,
        #0b0d11fa 100%
      );
    }
  }
  &__checkbox {
    position: absolute;
    left: 0px;
    right: 0px;
    top: 0px;
    bottom: 0px;
    display: flex;
    font-size: 0px;
    z-index: 99;
    ::v-deep {
      .el-checkbox {
        margin: 0px;
        padding: 0px;
        font-size: 0px;
        display: flex;
        align-items: flex-start;
        justify-content: flex-end;
        flex: 1;
        padding: 15px;
        &__inner {
          margin: 0px;
          &::after {
            border: 2px solid #495271;
            border-left: 0;
            border-top: 0;
          }
        }
        &__label {
          position: relative;
          display: block;
          flex: 1;
          z-index: 2;
          text-align: center;
          letter-spacing: 0px;
          color: #ffffff;
          font-weight: 500;
          font-size: 18px;
          line-height: 23px;
        }
        &__input.is-checked {
          .el-checkbox__inner {
            background-color: #00ffb3;
          }
        }
      }
    }
  }
}
</style>
